<?php
/***************************************************************
*  Copyright notice
*
*  (c) 1999-2004 Kasper Skaarhoj (kasperYYYY@typo3.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/* Created by Hendrik Reimers (kern23)
   www.kern23.de
   info@kern23.de
*/

require_once(PATH_tslib.'class.tslib_pibase.php');

// TypoScript Condition Function
function tx_xmlxpath_condition($useTypoScriptObj) {
	$xxObj = new tx_xmlxpath();
	return $xxObj->conditionCall($useTypoScriptObj);
}

// Main class
class tx_xmlxpath extends tslib_pibase {
	var $extKey = 'xml_xpath';
	
	/**
	 * Call as user func in typoscript
	 */
	public function main($content,$conf = false) {
		// Get the config
		$this->conf = $this->getExtConf($conf);
		
		// Let's go...
		return $this->parseXML();
	}
	
	// Aufruf von Conditions
	public function conditionCall(&$useTypoScriptObj) {
		// Initiate TypoScript
		$tsArray = $this->_cond_loadTS();
		if ( empty($tsArray) ) return false;
		
		// Init variables
		$itemList = explode(".",$useTypoScriptObj);
		
		// Load the selected TS
		if ( sizeof($itemList) > 0 ) {
			for ( $i = 0; $i < sizeof($itemList); $i++ ) {
				if ( strlen(trim($itemList[$i])) > 0 ) {
					if ( $i < sizeof($itemList) - 1) {
						$tsArray = $tsArray[$itemList[$i]."."];
					} else {
						$objType = $tsArray[$itemList[$i]];
						$objData = $tsArray[$itemList[$i]."."];
					}
				}
			}
		}
		
		// Free Memory
		unset($itemList,$tsArray);
		
		// Alternative way to get a cObj to render ts (cause its here note available)
		$GLOBALS['TSFE']->newCObj(); 
		$result = (boolean)$GLOBALS['TSFE']->cObj->cObjGetSingle($objType,$objData);
		unset($GLOBALS['TSFE']->cObj);
		
		return $result;
	}
	
	// Only needed by the conditionCall()
	// Source: http://www.sk-typo3.de/Typoscript-einer-Seite-aus-BE-Modul.212.0.html
	private function _cond_loadTS() {
		if ( empty($GLOBALS['TSFE']->tmpl->config) ) return false;
		
		$tsParser  = t3lib_div::makeInstance('t3lib_TSparser');
		$tsParser->parse(implode("\n",$GLOBALS['TSFE']->tmpl->config));
		$tsArray = $tsParser->setup;
		
		if ( sizeof($tsArray) > 0 ) {
			return $tsArray;
		} else return false;
	}
	
	private function parseXML() {
		// Load the File / URL
		$data = $this->getData();
		
		if ( strlen($data) <= 0 ) {
			return false;
		} else {
			// Create the XML Object
			$xml = $this->convertToXML($data);
			unset($data); # Free memory
			
			// Available?
			if ( !$xml ) return false;
			
			// Debug
			if ( $this->conf['debug'] == 1 ) die(print_r($xml));
			
			// Let's select by XPATH
			return $this->xpath($xml);
		}
	}
	
	private function xpath(&$xml,$xpath = null) {
		// Renders the XPATH String
		if ( !$xpath ) $xpath = $this->conf['xpath.'];
		$xpath = ( is_array($xpath['path.']) ) ? $this->parseTypoScriptObj($xpath['path'],$xpath['path.']) : $xpath['path'];
		
		// Get result by XPATH
		$result = $xml->xpath($xpath);
		
		if ( sizeof($result) > 0 ) {
			// Start Variables
			$output = '';
			
			// Render all Object items
			for ( $i = 0; $i < $this->conf['xpath.']['limit']; $i++ ) {
				// Load the Item
				$item = &$result[$i];
				
				// Render the marks
				$markerArray = array();
				if ( is_array($this->conf['marks.']) ) {
					foreach ( $this->conf['marks.'] as $key => $data ) {
						if ( $item ) {
							$key     = str_replace('.','',$key);
							$mResult = $item->xpath($data['path']);
							
							if ( $data['listNum'] >= 0 ) {
								$mResult = $mResult[$data['listNum']];
							}
							
							// Convert
							if ( trim($this->conf['xpath.']['retVal']) == 'boolean' ) {
								$mResult = ( $mResult ) ? true : false;
							} elseif ( trim($this->conf['xpath.']['retVal']) == 'string' ) {
								$mResult = (string)$mResult;
							}
							
							// Parse cObject with result
							if ( is_array($data['cObject.']) ) {
								$cObj = $this->replaceXpathTS($data['cObject.'],$mResult,'###XPATH_RESULT###');
								$cObj = $this->parseTypoScriptObj($data['cObject'],$cObj);
							} elseif ( strlen($data['cObject']) > 0 ) {
								$cObj = str_replace('###XPATH_RESULT###',$mResult,$data['cObject']);
							} else {
								$cObj = $mResult;
							}
							
							// Insert
							$markerArray['###'.strtoupper($key).'###'] = $cObj;
						}
					}
				}
				
				// Convert
				if ( trim($this->conf['xpath.']['retVal']) == 'boolean' ) {
					$item = ( $item ) ? true : false;
				} elseif ( trim($this->conf['xpath.']['retVal']) == 'string' ) {
					$item = (string)$item;
				}
				
				// Parse it into the Render Object
				if ( is_array($this->conf['renderObj.']) ) {
					$renderObj = $this->replaceXpathTS($this->conf['renderObj.'],$item,'###XPATH_RESULT###');
					
					if ( sizeof($markerArray) > 0 ) {
						foreach ( $markerArray as $key => $val ) {
							$renderObj = $this->replaceXpathTS($renderObj,$val,$key);
						}
					}
					
					$output   .= $this->parseTypoScriptObj($this->conf['renderObj'],$renderObj);
				} elseif ( strlen($this->conf['renderObj']) > 0 ) {
					$output .= str_replace('###XPATH_RESULT###',$item,$this->conf['renderObj']);
				} else $output .= $item;
			}
			
			return $output;
		} else return false;
	}
	
	// Replaces Marker in TypoScript
	private function replaceXpathTS($renderObj,&$newVal,$marker) {
		foreach ( $renderObj as $objKey => $objVal ) {
			if ( is_array($objVal) ) {
				$objVal = $this->replaceXpathTS($objVal,$newVal,$marker);
				$renderObj[$objKey] = $objVal;
			} else {
				$renderObj[$objKey] = str_replace($marker,$newVal,$objVal);
			}
		}
		
		return $renderObj;
	}
	
	// Converts a string to XML
	private function convertToXML(&$string) {
		# Boring Namespace Conversion
		$string = str_replace("xmlns=","ns=",$string);
		$string = str_replace("xmlns:","ns:",$string);
		#$string = preg_replace('/<(\/|)([a-z]{1,}):([a-z]{1,}[^>])(\ .*|)>/msiU',"<$1$3$4>",$string);
		
		# Create the XML Object
		$xml = @simplexml_load_string($string);
		$xml = new SimpleXMLElement($xml->asXML());
		
		# Register the Namespaces
		$namespaces = $xml->getNamespaces(true);
		if ( sizeof($namespaces) > 0 ) {
			foreach ($namespaces as $prefix => $ns) {
				$xml->registerXPathNamespace($prefix, $ns);
			}
		}
		unset($namespaces);
		
		# Return
		return $xml;
	}
	
	// Load the Data
	private function getData() {
		// Cache prfen
		if ( $this->conf['cache.']['enable'] == 1 ) {
			if ( file_exists($this->conf['cache.']['path'].$this->conf['cache.']['file']) ) {
				$cache = $this->loadCache();
				
				if ( $cache['timestamp'] < time() ) {
					return $this->reloadCache();
				}
				
				return $cache['data'];
			} else {
				return $this->reloadCache();
			}
		} else return $this->loadExternal();
	}
	
	// Recreates the cache file
	private function reloadCache() {
		// Get the Data
		$data = $this->loadExternal();
		
		// Write cache
		$fp = fopen($this->conf['cache.']['path'].$this->conf['cache.']['file'],'w+');
		fputs($fp,serialize(array('timestamp' => (time() + $this->conf['cache.']['timeout']),'data' => rawurlencode($data))));
		fclose($fp);
		
		return $data;
	}
	
	// Loads the Cache file
	private function loadCache() {
		$fileName = $this->conf['cache.']['path'].$this->conf['cache.']['file'];
		
		if ( file_exists($fileName) ) {
			$cache = unserialize(file_get_contents($fileName));
			$cache['data'] = rawurldecode($cache['data']);
			
			return $cache;
		} else return false;
	}
	
	// Loads external File or URL
	private function loadExternal() {
		// Daten neu laden
		if ( $this->conf['template'] == 'URL' ) {
			if ( !empty($this->conf['template.']['url']) ) {
				$this->conf['template.']['value'] = $this->conf['template.']['url'];
			}
			
			$url = $this->parseTypoScriptObj('TEXT',$this->conf['template.']);
			
			return t3lib_div::getURL($url);
		} else {
			return $this->parseTypoScriptObj($this->conf['template'],$this->conf['template.']);
		}
	}
	
	// Parses a typoscript object
	private function parseTypoScriptObj($objType,$objArray) {
		if ( (!empty($objType)) && (sizeof($objArray) > 0) ) {
			return $this->cObj->cObjGetSingle($objType,$objArray);
		} else return false;
	}
	
	// Loads the Extension config from the extMgr config
	private function getExtConf(&$conf) {
		return ( is_array($conf['conf.']) ) ? $conf['conf.'] : $GLOBALS['TSFE']->tmpl->setup['plugin.']['xml_xpath.']['conf.'];
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/weather_control/class.condition.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/weather_control/class.condition.php']);
}

?>
